<template>
  <div class="auth__content-social-wrapper">
    <a-button
      shape="circle"
      size="large"
      icon="google"
      class="auth__content-social__button"
      @click="loginWithGoogle()"
    />
    <a-button
      shape="circle"
      size="large"
      icon="facebook"
      class="auth__content-social__button"
    />
  </div>
</template>

<script>
import { mapActions } from 'vuex'
import { db, auth, googleProvider } from '~/firebase'

export default {
  name: 'Social',
  methods: {
    ...mapActions('user', ['login']),
    async loginWithGoogle() {
      try {
        const userRef = db.collection('user')

        await auth.signInWithPopup(googleProvider)

        const { uid, email, photoURL, displayName } = await auth.currentUser
        const token = await auth.currentUser.getIdToken(true)

        const { exists } = await userRef.doc(uid).get()

        const userData = {
          uid,
          email,
          photoURL,
          displayName,
          token,
          isVerified: true
        }

        if (exists) {
          await this.login({
            uid,
            email,
            photoURL,
            displayName,
            token,
            isVerified: true
          })

          this.$router.push({ path: '/admin' })
        } else {
          await userRef
            .doc(uid)
            .set({ uid, email, photoURL, displayName, isVerified: true })
          await this.login(userData)

          this.$router.push({ path: '/admin' })
        }
      } catch (error) {
        console.log(error)
      }
    }
  }
}
</script>

<style lang="less" scoped>
.auth__content {
  &-social {
    &-wrapper {
      display: flex;
      flex-direction: row;
      align-items: center;
      justify-content: center;
      margin-bottom: 15px;
    }

    &__button {
      margin: 10px;
    }
  }
}
</style>
